	output d:\assemble\sources.v41\rotozoom\rotozoom.acx

OPT_FULL_PATHNAMES

	lea objet_application,a1

	include rotozoom.def
	include visual41.s
	include rotozoom.hs
	include rotozoom.obj

	comment HEAD=7
	section TEXT

*---------------------------------------------------------------------------
custom_inits:
	tst GWVA_APP_OBJ_IS_ACC_PRG
	beq.s .acc
	bset #GWVA_APP_BIT_MENU,objet_application+GWVA_APP_OBJ_FLAGS	; menu principal
	bset #GWVA_APP_BIT_BACKGROUND,objet_application+GWVA_APP_OBJ_FLAGS	; fond
.acc:	rts

*---------------------------------------------------------------------------
acc_open:
menu_open:	

	tst.l ptr_load_tab_zoom
	bne.s .tab_zoom_already_loaded
	lea filename_tab_zoom,a0
	move.w #RAM_TT_ST,d0
	bsr LOAD_FILE_IN_MEM
	tst.l d0
	ble .erreur_loading_components
	move.l a0,ptr_load_tab_zoom
	add.l d0,a0
	move.l a0,ptr_fin_tab_zoom
.tab_zoom_already_loaded:

	cmp.w #16,GWVA_APP_OBJ_VDI_WORKSTATION_EXTD+4*2
	beq.s ._16bitpixel

	cmp.w #8,GWVA_APP_OBJ_VDI_WORKSTATION_EXTD+4*2
	bne .pas8bitpixel_ni16bitpixel

	tst.l ptr_load_palette_256
	bne.s .pal_256_already_loaded
	lea filename_palette_256,a0
	move.w #RAM_TT_ST,d0
	bsr LOAD_FILE_IN_MEM
	tst.l d0
	ble.s .erreur_loading_components
	move.l a0,ptr_load_palette_256
.pal_256_already_loaded:

	tst.l ptr_load_map_256
	bne.s .map_256_already_loaded
	lea filename_map_256,a0
	move.w #RAM_TT_ST,d0
	bsr LOAD_FILE_IN_MEM
	tst.l d0
	ble.s .erreur_loading_components
	move.l a0,ptr_load_map_256
.map_256_already_loaded:

	bra.s .open_dialog

._16bitpixel:
	tst.l ptr_load_map_TC
	bne.s .map_TC_already_loaded
	lea filename_map_TC,a0
	move.w #RAM_TT_ST,d0
	bsr LOAD_FILE_IN_MEM
	tst.l d0
	ble.s .erreur_loading_components
	move.l a0,ptr_load_map_TC
.map_TC_already_loaded:

.open_dialog
	lea objet_fenetre1,a0
	bsr GWVA_WIND_OBJ_PRG_CREATE_OPEN_ONE_WIND
	rts

.erreur_loading_components:
	bsr FREE_ALL_MEM

	move #ALERT_FILENOTFND,d0
	move #1,d1
	bsr RSC_ALERT_BOX
	rts

.pas8bitpixel_ni16bitpixel:
	bsr FREE_ALL_MEM

	move #ALERT_NO_16_8BIT,d0
	move #1,d1
	bsr RSC_ALERT_BOX
	rts

menu_info:	lea objet_fenetre3,a0
	bsr GWVA_WIND_OBJ_PRG_CREATE_OPEN_ONE_WIND
	rts

FREE_ALL_MEM:
	MFREE ptr_load_palette_256
	clr.l ptr_load_palette_256
	MFREE ptr_load_map_TC
	clr.l ptr_load_map_TC
	MFREE ptr_load_map_256
	clr.l ptr_load_map_256
	MFREE ptr_load_tab_zoom
	clr.l ptr_load_tab_zoom
	rts

routine_menu_quit:
app_term:
acc_close:
	; quoi qu'il arrive, il y a 1 delete all win

	tst GWVA_APP_OBJ_IS_ACC_PRG
	bne VISUAL40_END

	rts

*---------------------------------------------------------------------
event_timer_rotozoom:
	lea objet_fenetre2,a0
	bsr GWVA_WIND_OBJ_PRG_TEST_IF_WIND_OPENED
	tst d7
	bmi.s .pas_de_fenetre

	cmp.w #16,GWVA_APP_OBJ_VDI_WORKSTATION_EXTD+4*2
	bne.s .pas16bitpixel

	bsr ROTOZOOM

	bra.s .update_window
.pas16bitpixel:

	cmp.w #8,GWVA_APP_OBJ_VDI_WORKSTATION_EXTD+4*2
	bne.s .pas8bitpixel

	bsr ROTOZOOM_256

.pas8bitpixel:

.update_window:

*	lea objet_fenetre2,a0
*	move.w #0,d0
*	move.w #7,d1
*	move.w #0,d2
*	bsr GWVA_FORM_WIND_OBJ_PRG_REDRAW_PART

	lea objet_fenetre2,a0
	move #16,GWVA_APP_OBJ_MSG_BUF+2*2

	move.l GWVA_WIND_OBJ_INTERNAL_DX(a0),GWVA_APP_OBJ_MSG_BUF+4*2
	move.l GWVA_WIND_OBJ_INTERNAL_W(a0),GWVA_APP_OBJ_MSG_BUF+6*2
	movem.w GWVA_WIND_OBJ_CONTENTS_DX(a0),d0-d1
	add.w d0,GWVA_APP_OBJ_MSG_BUF+4*2
	add.w d1,GWVA_APP_OBJ_MSG_BUF+4*2+2
	sub.w d0,GWVA_APP_OBJ_MSG_BUF+6*2
	sub.w d1,GWVA_APP_OBJ_MSG_BUF+6*2+2

	move #0,GWVA_APP_OBJ_MSG_EXT_BUF
	move #7,GWVA_APP_OBJ_MSG_EXT_BUF+2
	move #0,GWVA_APP_OBJ_MSG_EXT_BUF+4		; contents

	bsr GWVA_WIND_OBJ_PRG_WM_REDRAW
	rts

.pas_de_fenetre:
	move.l #2000,GWVA_APP_OBJ_COUNT+objet_application
	rts

*---------------------------------------------------------------------

wind1_bton_ok_click:
	move.w #FORM_SIZE_XY,d0
	move.w #FSXY_TEXT_WIDTH,d1
	bsr RETURN_TEXT_OBJ_IN_FORM_OBJ_PTR
	move.l a1,a0
	clr.b d0
	bsr DECI2VALUE
	move.w d1,roto_zoom_w

	move.w #FORM_SIZE_XY,d0
	move.w #FSXY_TEXT_HEIGHT,d1
	bsr RETURN_TEXT_OBJ_IN_FORM_OBJ_PTR
	move.l a1,a0
	clr.b d0
	bsr DECI2VALUE
	move.w d1,roto_zoom_h

	lea objet_fenetre1,a0
	bsr GWVA_WIND_OBJ_PRG_DELETE_ONE_WIND

	lea objet_fenetre2,a0
	bsr GWVA_WIND_OBJ_PRG_DELETE_ONE_WIND

	lea objet_fenetre2,a0
	move.l GWVA_WIND_OBJ_SPEC_PTR(a0),a1
	move.l roto_zoom_w,GWVA_WBITM_OBJ_IMG_WIDTH(a1)
	move.w GWVA_APP_OBJ_VDI_WORKSTATION_EXTD+4*2,GWVA_WBITM_OBJ_NBR_BITPLANES(a1)
	move.l ptr_load_palette_256,GWVA_WBITM_OBJ_PAL_PTR(a1)
	clr.l GWVA_WBITM_OBJ_AFF_DX(a1)
	move.l roto_zoom_w,GWVA_WIND_OBJ_FIRST_W(a0)
	move.w roto_zoom_w,d0
	mulu roto_zoom_h,d0

	move.w GWVA_APP_OBJ_VDI_WORKSTATION_EXTD+4*2,d1
	ext.l d1
	mulu.l d1,d0
	divu.l #8,d0	; taille du buffer en octet
	move.l d0,d1

	save.l d1/a0-a1
	MXALLOC #RAM_TT_ST,d0
	load.l d1/a0-a1
	tst.l d0
	ble .pas_de_memoire

	move.l d0,GWVA_WBITM_OBJ_DATA_PTR(a1)

	move.l d0,a2
.clear_buf:	clr.b (a2)+
	sub.l #1,d1
	bne.s .clear_buf

	lea objet_fenetre2,a0
	bsr GWVA_WIND_OBJ_PRG_CREATE_OPEN_ONE_WIND
	tst d7
	bpl.s .wind_created

	move.l ([GWVA_WIND_OBJ_SPEC_PTR,a0],GWVA_WBITM_OBJ_DATA_PTR),d0
	MFREE d0

	rts

.wind_created:
	lea objet_fenetre2,a0
	move.l GWVA_WIND_OBJ_SPEC_PTR(a0),a1
	move.l GWVA_WBITM_OBJ_DATA_PTR(a1),a0

	cmp.w #16,GWVA_APP_OBJ_VDI_WORKSTATION_EXTD+4*2
	bne.s .pas16bitpixel

	movem.w roto_zoom_w,d0/d1
	bsr ROTO_INIT

	bra.s .end_create_window
.pas16bitpixel:

	cmp.w #8,GWVA_APP_OBJ_VDI_WORKSTATION_EXTD+4*2
	bne.s .pas8bitpixel

	move.w roto_zoom_w,d0
	mulu roto_zoom_h,d0

	move.w GWVA_APP_OBJ_VDI_WORKSTATION_EXTD+4*2,d1
	ext.l d1
	mulu.l d1,d0
	divu.l #8,d0	; taille du buffer en octet

	save.l a0
	MXALLOC #RAM_TT_ST,d0
	load.l a0
	tst.l d0
	ble.s .pas_de_memoire2

	move.l d0,a1
	move.l d0,buffer_sup
	movem.w roto_zoom_w,d0/d1
	bsr ROTO_INIT_256

.pas8bitpixel:

.end_create_window:

	move.l #1,GWVA_APP_OBJ_COUNT+objet_application

	rts
.pas_de_memoire2:
	MFREE GWVA_WBITM_OBJ_DATA_PTR(a1)
.pas_de_memoire:
	rts
*---------------------------------------------------------------------

wind1_bton_annule_click:
	bsr GWVA_WIND_OBJ_PRG_DELETE_ONE_WIND
	rts

*---------------------------------------------------------------------
close_fenetre_rotozoom:
	MFREE GWVA_WBITM_OBJ_DATA_PTR(a1)
	MFREE buffer_sup
	bsr FREE_ALL_MEM
	rts
*---------------------------------------------------------------------

	include visurot2.s

*---------------------------------------------------------------------

	section DATA

	ifnd OPT_FULL_PATHNAMES
filename_palette_256:	dc.b 'pal_256.bin',0
filename_map_TC:	dc.b 'map.bin',0
filename_map_256:	dc.b 'map_256.bin',0
filename_tab_zoom:	dc.b 'tab_zoom.bin',0
	else
filename_palette_256:	dc.b 'd:\assemble\sources.v41\rotozoom\pal_256.bin',0
filename_map_TC:	dc.b 'd:\assemble\sources.v41\rotozoom\map.bin',0
filename_map_256:	dc.b 'd:\assemble\sources.v41\rotozoom\map_256.bin',0
filename_tab_zoom:	dc.b 'd:\assemble\sources.v41\rotozoom\tab_zoom.bin',0
	endc

pal8explose
n	set	0
	rept	256
	dc.b	(n>>0)&1
	dc.b	(n>>1)&1
	dc.b	(n>>2)&1
	dc.b	(n>>3)&1
	dc.b	(n>>4)&1
	dc.b	(n>>5)&1
	dc.b	(n>>6)&1
	dc.b	(n>>7)&1
n	set	n+1
	endr


	section BSS

roto_zoom_w:	ds.w 1
roto_zoom_h:	ds.w 1
buffer_sup:		ds.l 1

ptr_load_palette_256:	ds.l 1
ptr_load_map_TC:	ds.l 1
ptr_load_map_256:	ds.l 1
ptr_load_tab_zoom:	ds.l 1
ptr_fin_tab_zoom:	ds.l 1	; calcul

MY_BUF	DS.L	1	
BUF_256	DS.L	1
PARAM	DS.L	32
POSX	DS.W	1
POSY	DS.W	1
Y	DS.W	1
INCX	DS.W	1
INCY	DS.W	1
SCREENX	DS.W	1
SCREENY	DS.W	1

 END
